! Самостоятельная работа, Кремер Илья | http://kremer.pro/blog/?post_type=post&p=75

program main
	include "mpif.h"
	integer ierr, pid, np, status(MPI_STATUS_SIZE)
	integer next, prev
	integer, parameter :: N = 15000 ! msg size
	integer a(N) ! msg
	double precision start

	a = 0
	call mpi_init(ierr)
	call mpi_comm_rank(MPI_COMM_WORLD, pid, ierr)
	call mpi_comm_size(MPI_COMM_WORLD, np,  ierr)

	if (np == 1) then
		print *, "BAD NP"
		call mpi_finalize(ierr)
		stop
	endif

	if (pid == 0) then
		start = mpi_wtime()
		call mpi_send(a, N, MPI_INTEGER, 1,      5, MPI_COMM_WORLD, ierr)
		call mpi_recv(a, N, MPI_INTEGER, np - 1, 5, MPI_COMM_WORLD, status, ierr)
		! вывод сообщения
		print '(a, f12.8, a)', "затрачено ", mpi_wtime() - start, "   сек"
	else if (pid == np - 1) then
		next = 0
		prev = pid - 1
	else
		next = pid + 1
		prev = pid - 1
	endif

	if (pid /= 0) then
		call mpi_recv(a, N, MPI_INTEGER, prev, 5, MPI_COMM_WORLD, status, ierr)
		! какое-то изменение сообщения
		call mpi_send(a, N, MPI_INTEGER, next, 5, MPI_COMM_WORLD, ierr)
	endif

	call mpi_finalize(ierr)
end program

